<?php
//=================================================================
// KOOBI R7 - CMS - PORTALSOFTWARE(c) DREAM4(r) 
// HTTP://WWW.DREAM4.DE
//=================================================================
// ACHTUNG!
// DIESER PROGRAMMCODE IST URHERRECHTLICH GESCHUETZT
// DIE URHEBERRECHTE LIEGEN BEI DEN JEWEILIGEN AUTOREN.
// AENDERUNGEN IN DIESER DATEI ERFOLGEN AUF EIGENE GEFAHR!
// ES IST NICHT GESTATTET, DEN COPYRIGHTHINWEIS ZU AENDERN ODER ZU
// ENTFERNEN. NUR WENN SIE EINE COPYRIGHTHINWEIS-ENTFERNUNG BESTELLT
// HABEN, DUERFEN SIE DIESEN ENTFERNEN.
//================================================================
// BEI FRAGEN WENDEN SIE SICH BITTE AN: KONTAKT@DREAM4.DE
//=================================================================
function Seo($Ausgabe)
{
	// SPRACHVARIABLEN LADEN...
	$GLOBALS['tmpl']->config_load(BASE_DIR . '/lang/' . $_SESSION['lang'] . '/rewrite.txt');
	$config_vars = $GLOBALS['tmpl']->get_config_vars();

	// ÜBERPRÜFEN AUF ÄNDERUNGEN
	$sql = $GLOBALS['db']->Query("SELECT Seo_Sprachen FROM " . PREFIX . "_einstellungen WHERE Id = '1'");
	$row = $sql->fetchrow();

	$sql_l = $GLOBALS['db']->Query("SELECT Sprachcode FROM " . PREFIX . "_sprachen WHERE Aktiv = '1'");
	while($lang = $sql_l->fetchrow())
	{
		$langs[] = $lang->Sprachcode;
	}	

	$sqllang = explode(";", $row->Seo_Sprachen);
	foreach($sqllang as $slang)
	{	
		$svalue = explode(":", $slang);
		$sql_lang[] = $svalue[0];
		$sql_time[$svalue[0]] = @$svalue[1];
	}

	if(count(array_diff($sql_lang, $langs)) != 1 || $row->Seo_Sprachen=='') $create = 1;

	$fp = @fopen(BASE_DIR. "/.htaccess", "r");
	$htempty = @fread($fp,1);
	@fclose($fp);
		
	foreach($langs as $l)
	{ 
		$filetime = filemtime(BASE_DIR ."/lang/". $l ."/rewrite.txt");
		$sql_data[] = $l . ":" . $filetime;
		if(isset($sql_time[$l])) if($sql_time[$l] < $filetime) $create = 1;
	}

	$filetime = filemtime(BASE_DIR ."/functions/Func.BuildMod.php");
	$sql_data[] = "func:" . $filetime;
	if(isset($sql_time['func'])) if($sql_time['func'] < $filetime) $create = 1;

	if($htempty=='')  $create = 1;
	// ERSTELLEN / UPDATE DER DATENBANK
	if(isset($create)) if(!BuildMod($sql_data) == true) return $Ausgabe;

	// MODREWRITE VERHINDERN - SCHRITT 1
	preg_match_all("/<textarea(.*?)>(.*?)<\/textarea>/is", $Ausgabe, $treffer_textarea);

	$num_textarea = count($treffer_textarea) + 1;
	for ($i = 0; $i <= $num_textarea; $i++)
	{
   		@$Ausgabe = str_replace($treffer_textarea[0][$i],"___REWRITE_TEXT_".$i."___", $Ausgabe);
	}

	preg_match_all('/{* START NO-REWRITE *}(.*?){* END NO-REWRITE *}/is', $Ausgabe, $treffer_rewrite);
		
	$num_rewrite = count($treffer_rewrite) + 1;
	for ($i = 0; $i <= $num_rewrite; $i++)
	{
   		@$Ausgabe = str_replace($treffer_rewrite[0][$i],"___REWRITE_".$i."___", $Ausgabe);
	}

	# DOMAIN / TAGS / LINKS
	$_DOMAIN = strpos($_SERVER['SCRIPT_NAME'],"index.php") ? str_replace("/index.php","",$_SERVER['SCRIPT_NAME']) : "";
	$_TAGS = array("URL=","background:url(","background-url:url(", "src=", "src=\'", "href=","onclick=", "window.open(");
	$_LINK = array("index.php");

	# ERMITTELN DER ORDER IM VERZEICHNIS
	$_ORDNER = array();
	{ 
		$handle = opendir(BASE_DIR); 
		while ($file = readdir ($handle)) 
		{ 
			if($file{0} != '.') 
			{ 
				if(is_dir(BASE_DIR.'/'.$file)) 
				{ 
					$folderArray[] = $file; 
				} 
			} 
		} 
		closedir($handle); 

		if(isset($folderArray)) 
		{ 
			asort($folderArray); 
			foreach($folderArray as $row) 
			{ 
				unset($folderArray2);
				array_push($_ORDNER, $row);
			} 
		} 
	}	

	# ADRESSEN ANPASSEN
	foreach($_ORDNER as $o)
	{
		foreach($_TAGS as $t)
		{
			$Ausgabe = str_replace($t.'"'.$o.'/',$t.'"'.$_DOMAIN.'/'.$o.'/', $Ausgabe);
			$Ausgabe = str_replace($t."'".$o."/",$t."'".$_DOMAIN."/".$o."/", $Ausgabe);
			$Ausgabe = str_replace($t . $o."/",$t . $_DOMAIN."/".$o."/", $Ausgabe);
		}
	}

	foreach($_LINK as $l)
	{
		$Ausgabe = str_replace("'".$l, "'".$_DOMAIN.'/'.$l, $Ausgabe);
		$Ausgabe = str_replace('"'.$l, '"'.$_DOMAIN."/".$l, $Ausgabe);
	}

	
	// ========================================================================
	// BEGINN DER MODREWRITE-REGELN	
	// ========================================================================
	
	$Ausgabe = preg_replace("/&amp;lang=([a-zA-Z]*)/","", $Ausgabe);
	$Ausgabe = preg_replace("/index.php([?])p=shop&amp;currency=([0-9]*)&amp;redirect=(.*?)/", $config_vars['currency']."/\\2/\\3", $Ausgabe);

	// Forums
	$f_array = array('showforums','showtopic','forum','newtopic','newpost','delpost','showforum');
	if(in_array($_REQUEST['p'], $f_array))
	{
		$Ausgabe = preg_replace("/index.php([?])p=showtopic&amp;print=1&amp;toid=([0-9]*)&amp;fid=([0-9]*)&amp;page=([0-9]*)&amp;t=([-A-Za-zÀ-ÖØ-öø-ÿ0-9-]*)/", $config_vars['topicprint']."/\\2/\\3/".$config_vars['page']."-\\4/\\5/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=showtopic&amp;print=1&amp;print_post=([0-9]*)&amp;toid=([0-9]*)&amp;t=([-A-Za-zÀ-ÖØ-öø-ÿ0-9-]*)/", $config_vars['postprint']."/\\2/\\3/\\4/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=showtopic&amp;toid=([0-9]*)&amp;fid=([0-9]*)&amp;t=([-A-Za-zÀ-ÖØ-öø-ÿ0-9-]*)&amp;print=1&amp;print_post=([0-9]*)/", $config_vars['topicprint']."/\\2/\\3/\\4/\\5/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=showtopic&amp;toid=([0-9]*)&amp;fid=([0-9]*)&amp;page=([0-9]*)&amp;t=([-A-Za-zÀ-ÖØ-öø-ÿ0-9-]*)/", $config_vars['topic']."/\\2/\\3/\\4/\\5/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=showtopic&amp;toid=([0-9]*)&amp;fid=([0-9]*)&amp;t=([-A-Za-zÀ-ÖØ-öø-ÿ0-9-]*)/", $config_vars['topic']."/\\2/\\3/\\4/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=showtopic&amp;toid=([0-9]*)&amp;pp=([0-9]*)&amp;page=([0-9]*)#pid_([0-9]*)/", $config_vars['topic']."/\\2/\\3/\\4/#\\5", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=showforums&amp;cid=([0-9]*)&amp;t=([-A-Za-zÀ-ÖØ-öø-ÿ0-9-]*)/", $config_vars['forums']."/\\2/\\3/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=forum&amp;action=show&amp;unit=h&amp;period=24/", $config_vars['last24']."/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=forum&amp;action=search_mask&amp;fid=([0-9]*)/", $config_vars['search_mask']."/\\2/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=forum&amp;action=search_mask/", $config_vars['search_mask']."/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=forum&amp;action=print&amp;what=posting&amp;id=([0-9]*)&amp;page=([0-9]*)&amp;pp=([0-9]*)/", $config_vars['userposting']."/\\2/\\3/\\4/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=forum&amp;action=print&amp;what=topicsempty&amp;page=([0-9]*)&amp;pp=([0-9]*)/", $config_vars['forumsemptytopics']."/\\2/\\3/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=forum&amp;action=print&amp;what=topicsempty/", $config_vars['forumsemptytopics']."/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=forum&amp;action=print&amp;what=posting&amp;id=([0-9]*)/", $config_vars['userposting']."/\\2/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=forum&amp;action=print&amp;what=subscription&amp;id=([0-9]*)/", $config_vars['subscription']."/\\2/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=forum&amp;action=print&amp;what=subscription/", $config_vars['subscriptions']."/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=forum&amp;action=print&amp;what=lastposts/", $config_vars['forumslastposts']."/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=forum&amp;action=markread&amp;what=forum&amp;ReadAll=1/", $config_vars['markread']."/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=forum&amp;action=markread&amp;what=forum&amp;id=([0-9]*)/", $config_vars['markread']."/\\2/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=forum&amp;action=addsubscription&amp;t_id=([0-9]*)/", $config_vars['addsubscription']."/\\2/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=newtopic&amp;fid=([0-9]*)/", $config_vars['newtopic']."/\\2/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=newpost&amp;action=edit&amp;pid=([0-9]*)&amp;toid=([0-9]*)/", $config_vars['editpost']."/\\2/\\3/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=newpost&amp;toid=([0-9]*)&amp;pp=([0-9]*)&amp;num_pages=([0-9]*)/", $config_vars['newpost']."/\\2/\\3/\\4/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=newpost&amp;action=quote&amp;pid=([0-9]*)&amp;toid=([0-9]*)/", $config_vars['newquote']."/\\2/\\3/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=newpost&amp;toid=([0-9]*)/", $config_vars['newpost']."/\\2/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=delpost&amp;pid=([0-9]*)&amp;toid=([0-9]*)/", $config_vars['delpost']."/\\2/\\3/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=forum&amp;action=getfile&amp;id=([0-9]*)&amp;f_id=([0-9]*)&amp;t_id=([0-9]*)/", $config_vars['getfile']."/\\2/\\3/\\4/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=showforum&amp;fid=([0-9]*)&amp;unit=([-A-Za-zÀ-ÖØ-öø-ÿ0-9- ]*)&amp;period=([-_A-Za-zÀ-ÖØ-öø-ÿ0-9- ]*)&amp;sortby=([-_A-Za-zÀ-ÖØ-öø-ÿ0-9- ]*)&amp;sort=([-_A-Za-zÀ-ÖØ-öø-ÿ0-9- ]*)&amp;pp=([0-9]*)&amp;page=([0-9]*)/", $config_vars['forumpage']."/\\2/\\3/\\4/\\5/\\6/\\7/\\8/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=showforum&amp;fid=([0-9]*)&amp;sortby=([-_A-Za-zÀ-ÖØ-öø-ÿ0-9- ]*)&amp;sort=([-_A-Za-zÀ-ÖØ-öø-ÿ0-9- ]*)/", $config_vars['forumpage']."/\\2/\\3/\\4/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=showforum&amp;fid=([0-9]*)&amp;t=([-A-Za-zÀ-ÖØ-öø-ÿ0-9-]*)/", $config_vars['forum']."/\\2/\\3/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=forum&amp;action=help&amp;hid=([0-9]*)&amp;sub=([-A-Za-zÀ-ÖØ-öø-ÿ0-9-]*)/", $config_vars['forumshelp']."/\\2/\\3/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=forum&amp;action=help/", $config_vars['forumshelp']."/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=showforums&amp;area=([0-9]*)/", $config_vars['forums']."/\\2/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=showforums/", $config_vars['forums']."/", $Ausgabe);
		
	} else {
		$Ausgabe = preg_replace("/index.php([?])p=showtopic&amp;toid=([0-9]*)&amp;pp=([0-9]*)&amp;page=([0-9]*)#pid_([0-9]*)/", $config_vars['topic']."/\\2/\\3/\\4/#\\5", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=showforums&amp;area=([0-9]*)/", $config_vars['forums']."/\\2/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=showforums/", $config_vars['forums']."/", $Ausgabe);
	}
	
	$Ausgabe = preg_replace("/index.php([?])p=members&amp;ud=([-A-Za-zÀ-ÖØ-öø-ÿ0-9-]*)&amp;selby=([-A-Za-zÀ-ÖØ-öø-ÿ0-9-]*)&amp;pp=([0-9]*)&amp;page=([0-9]*)/", $config_vars['users']."/\\2/\\3/\\4/\\5/", $Ausgabe);
	$Ausgabe = preg_replace("/index.php([?])p=members&amp;ud=([-A-Za-zÀ-ÖØ-öø-ÿ0-9-]*)&amp;pp=([0-9]*)&amp;page=([0-9]*)/", $config_vars['users']."/\\2/\\3/\\4/", $Ausgabe);
	$Ausgabe = preg_replace("/index.php([?])p=members&amp;area=([0-9]*)/", $config_vars['users']."/\\2/", $Ausgabe);
	$Ausgabe = preg_replace("/index.php([?])p=members/", $config_vars['users']."/", $Ausgabe);
	$Ausgabe = preg_replace("/index.php([?])p=user&amp;id=([0-9]*)&amp;area=([0-9]*)&amp;page=([0-9]*)/", $config_vars['userprofile']."/\\2/\\3/\\4/", $Ausgabe);
	$Ausgabe = preg_replace("/index.php([?])p=user&amp;id=([0-9]*)&amp;area=([0-9]*)/", $config_vars['userprofile']."/\\2/\\3/", $Ausgabe);
	$Ausgabe = preg_replace("/index.php([?])p=user&amp;id=([0-9]*)/", $config_vars['userprofile']."/\\2/", $Ausgabe);
	$Ausgabe = preg_replace("/index.php([?])p=useraction&amp;action=profile&amp;area=([0-9]*)/", $config_vars['editprofile']."/\\2/", $Ausgabe);
	$Ausgabe = preg_replace("/index.php([?])p=useraction&amp;action=profile/", $config_vars['editprofile']."/", $Ausgabe);
	$Ausgabe = preg_replace("/index.php([?])p=useraction&amp;action=changepass&amp;area=([0-9]*)/", $config_vars['changepass']."/\\2/", $Ausgabe);
	$Ausgabe = preg_replace("/index.php([?])p=useraction&amp;action=changepass/", $config_vars['changepass']."/", $Ausgabe);
	$Ausgabe = preg_replace("/index.php([?])p=forum&amp;action=ignorelist&amp;sub=add&amp;id=([0-9]*)/", $config_vars['ignore']."/\\2/", $Ausgabe);
	$Ausgabe = preg_replace("/index.php([?])p=forum&amp;action=ignorelist/", $config_vars['ignorelist']."/", $Ausgabe);
	$Ausgabe = preg_replace("/index.php([?])p=pn&amp;action=message&amp;id=([0-9]*)&amp;goto=inbox/", $config_vars['pn']."/". $config_vars['inbox']."/\\2/", $Ausgabe);
	$Ausgabe = preg_replace("/index.php([?])p=pn&amp;action=message&amp;id=([0-9]*)&amp;goto=outbox/", $config_vars['pn']."/". $config_vars['outbox']."/\\2/", $Ausgabe);
	$Ausgabe = preg_replace("/index.php([?])p=pn&amp;goto=inbox/", $config_vars['pn']."/". $config_vars['inbox']."/", $Ausgabe);
	$Ausgabe = preg_replace("/index.php([?])p=pn&amp;goto=outbox/", $config_vars['pn']."/". $config_vars['outbox']."/", $Ausgabe);
	$Ausgabe = preg_replace("/index.php([?])p=pn&amp;action=new&amp;to=([-=_A-Za-zÀ-ÖØ-öø-ÿ0-9- ]*)/", $config_vars['pn']."/". $config_vars['new']."/\\2/", $Ausgabe);
	$Ausgabe = preg_replace("/index.php([?])p=pn&amp;action=new/", $config_vars['pn']."/". $config_vars['new']."/", $Ausgabe);
	$Ausgabe = preg_replace("/index.php([?])p=pn/", $config_vars['pn']."/", $Ausgabe);

		
	// Shop
	if($_REQUEST['p']=='shop')
	{
		$Ausgabe = preg_replace("/index.php([?])shop_q=([-=_A-Za-zÀ-ÖØ-öø-ÿ0-9-+ ]*)&amp;man=([0-9]*)&amp;p=shop&amp;action=showproducts&amp;cid=([0-9]*)&amp;page=([0-9]*)&amp;limit=([0-9]*)&amp;pf=([-.0-9-]*)&amp;pt=([-.0-9-]*)&amp;topseller=1/", $config_vars['shop']."/".$config_vars['shop_products']."/".$config_vars['search']."/\\2/\\3/\\4/\\5/\\6/\\7/\\8/".$config_vars['shop_topseller_products']."/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])shop_q=([-=_A-Za-zÀ-ÖØ-öø-ÿ0-9-+ ]*)&amp;man=([0-9]*)&amp;p=shop&amp;action=showproducts&amp;cid=([0-9]*)&amp;page=([0-9]*)&amp;limit=([0-9]*)&amp;pf=([-.0-9-]*)&amp;pt=([-.0-9-]*)&amp;offers=1/", $config_vars['shop']."/".$config_vars['shop_products']."/".$config_vars['search']."/\\2/\\3/\\4/\\5/\\6/\\7/\\8/".$config_vars['shop_offer_products']."/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])shop_q=([-=_A-Za-zÀ-ÖØ-öø-ÿ0-9-+ ]*)&amp;man=([0-9]*)&amp;p=shop&amp;action=showproducts&amp;cid=([0-9]*)&amp;page=([0-9]*)&amp;limit=([0-9]*)&amp;pf=([-.0-9-]*)&amp;pt=([-.0-9-]*)&amp;lowamount=1/", $config_vars['shop']."/".$config_vars['shop_products']."/".$config_vars['search']."/\\2/\\3/\\4/\\5/\\6/\\7/\\8/".$config_vars['shop_lowamount_products']."/", $Ausgabe);
		
		$Ausgabe = preg_replace("/index.php([?])shop_q=([-=_A-Za-zÀ-ÖØ-öø-ÿ0-9-+ ]*)&amp;man=([0-9]*)&amp;p=shop&amp;action=showproducts&amp;cid=([0-9]*)&amp;page=([0-9]*)&amp;limit=([0-9]*)&amp;pf=([-.0-9-]*)&amp;pt=([-.0-9-]*)&amp;list=([-_A-Za-z-0-9]*)&amp;topseller=1/", $config_vars['shop']."/".$config_vars['shop_products']."/".$config_vars['search']."/\\2/\\3/\\4/\\5/\\6/\\7/\\8/\\9/".$config_vars['shop_topseller_products']."/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])shop_q=([-=_A-Za-zÀ-ÖØ-öø-ÿ0-9-+ ]*)&amp;man=([0-9]*)&amp;p=shop&amp;action=showproducts&amp;cid=([0-9]*)&amp;page=([0-9]*)&amp;limit=([0-9]*)&amp;pf=([-.0-9-]*)&amp;pt=([-.0-9-]*)&amp;list=([-_A-Za-z-0-9]*)&amp;offers=1/", $config_vars['shop']."/".$config_vars['shop_products']."/".$config_vars['search']."/\\2/\\3/\\4/\\5/\\6/\\7/\\8/\\9/".$config_vars['shop_offer_products']."/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])shop_q=([-=_A-Za-zÀ-ÖØ-öø-ÿ0-9-+ ]*)&amp;man=([0-9]*)&amp;p=shop&amp;action=showproducts&amp;cid=([0-9]*)&amp;page=([0-9]*)&amp;limit=([0-9]*)&amp;pf=([-.0-9-]*)&amp;pt=([-.0-9-]*)&amp;list=([-_A-Za-z-0-9]*)&amp;lowamount=1/", $config_vars['shop']."/".$config_vars['shop_products']."/".$config_vars['search']."/\\2/\\3/\\4/\\5/\\6/\\7/\\8/\\9/".$config_vars['shop_lowamount_products']."/", $Ausgabe);
		
		
		$Ausgabe = preg_replace("/index.php([?])shop_q=([-=_A-Za-zÀ-ÖØ-öø-ÿ0-9-+ ]*)&amp;man=([0-9]*)&amp;p=shop&amp;action=showproducts&amp;cid=([0-9]*)&amp;page=([0-9]*)&amp;limit=([0-9]*)&amp;pf=([-.0-9-]*)&amp;pt=([-.0-9-]*)&amp;list=([-_A-Za-z-0-9]*)/", $config_vars['shop']."/".$config_vars['shop_products']."/".$config_vars['search']."/\\2/\\3/\\4/\\5/\\6/\\7/\\8/\\9/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])shop_q=([-=_A-Za-zÀ-ÖØ-öø-ÿ0-9-+ ]*)&amp;man=([0-9]*)&amp;p=shop&amp;action=showproducts&amp;cid=([0-9]*)&amp;page=([0-9]*)&amp;limit=([0-9]*)&amp;pf=([-.0-9-]*)&amp;pt=([-.0-9-]*)/", $config_vars['shop']."/".$config_vars['shop_products']."/".$config_vars['search']."/\\2/\\3/\\4/\\5/\\6/\\7/\\8/", $Ausgabe);
		
		$Ausgabe = preg_replace("/index.php([?])p=shop&amp;action=showproducts&amp;page=([0-9]*)&amp;lowamount=1&amp;cid=([0-9]*)&amp;list=([-=_A-Za-zÀ-ÖØ-öø-ÿ- ]*)&amp;limit=([0-9]*)/", $config_vars['shop']."/".$config_vars['shop_products']."/\\2/\\3/".$config_vars['shop_lowamount_products']."/\\4/\\5/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=shop&amp;action=showproducts&amp;page=([0-9]*)&amp;offers=1&amp;cid=([0-9]*)&amp;list=([-=_A-Za-zÀ-ÖØ-öø-ÿ- ]*)&amp;limit=([0-9]*)/", $config_vars['shop']."/".$config_vars['shop_products']."/\\2/\\3/".$config_vars['shop_offer_products']."/\\4/\\5/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=shop&amp;action=showproducts&amp;page=([0-9]*)&amp;topseller=1&amp;cid=([0-9]*)&amp;list=([-=_A-Za-zÀ-ÖØ-öø-ÿ- ]*)&amp;limit=([0-9]*)/", $config_vars['shop']."/".$config_vars['shop_products']."/\\2/\\3/".$config_vars['shop_topseller_products']."/\\4/\\5/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=shop&amp;action=showproducts&amp;cid=([0-9]*)&amp;page=([0-9]*)&amp;limit=([0-9]*)&amp;t=([-=_A-Za-zÀ-ÖØ-öø-ÿ0-9- ]*)&amp;list=([-_A-Za-z-0-9]*)/", $config_vars['shop']."/".$config_vars['shop_products']."/\\2/\\3/\\4/\\5/\\6/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=shop&amp;action=showproducts&amp;cid=([0-9]*)&amp;page=([0-9]*)&amp;limit=([0-9]*)&amp;t=([-=_A-Za-zÀ-ÖØ-öø-ÿ0-9- ]*)/", $config_vars['shop']."/".$config_vars['shop_products']."/\\2/\\3/\\4/\\5/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=shop&amp;action=showproduct&amp;id=([0-9]*)&amp;cid=([0-9]*)&amp;pname=([-=_A-Za-zÀ-ÖØ-öø-ÿ0-9- ]*)/", $config_vars['shop']."/".$config_vars['shop_product']."/\\2/\\3/\\4/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=shop&amp;start=1/", $config_vars['shop']."/start/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=shop&amp;action=shippingcost/", $config_vars['shop']."/". $config_vars['shippingcost']."/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=shop&amp;action=showbasket/", $config_vars['shop']."/". $config_vars['showbasket']."/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=shop&amp;action=mylist&amp;subaction=load_list&amp;id=([0-9]*)/", $config_vars['shop']."/". $config_vars['mylist']."/\\2/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=shop&amp;action=mylist&amp;subaction=del_list&amp;id=([0-9]*)/", $config_vars['shop']."/". $config_vars['mylist']."/del/\\2/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=shop&amp;action=mylist/", $config_vars['shop']."/". $config_vars['mylist']."/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=shop&amp;action=mydownloads/", $config_vars['shop']."/". $config_vars['mydownloads']."/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=shop&amp;action=myorders&amp;show=([-=_A-Za-zÀ-ÖØ-öø-ÿ0-9- ]*)&amp;page=([0-9]*)/", $config_vars['shop']."/". $config_vars['myorders']."/\\2/\\3/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=shop&amp;action=myorders&amp;show=([-=_A-Za-zÀ-ÖØ-öø-ÿ0-9- ]*)/", $config_vars['shop']."/". $config_vars['myorders']."/\\2/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=shop&amp;action=myorders&amp;page=([0-9]*)/", $config_vars['shop']."/". $config_vars['myorders']."/-/\\2/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=shop&amp;action=myorders/", $config_vars['shop']."/". $config_vars['myorders']."/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=shop&amp;action=shoporder&amp;step=2/", $config_vars['shop']."/". $config_vars['shoporder']."/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=shop&amp;action=shoporder&amp;subaction=step([0-9]*)/", $config_vars['shop']."/". $config_vars['shoporder']."/". $config_vars['step']."/\\2/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=shop&amp;s=1&amp;action=showproducts&amp;list=([-=_A-Za-zÀ-ÖØ-öø-ÿ- ]*)/", $config_vars['shop']."/". $config_vars['search']."/\\2/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=shop&amp;s=1&amp;action=showproducts&amp;limit=([0-9]*)/", $config_vars['shop']."/". $config_vars['search']."/\\2/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=shop&amp;s=1&amp;action=showproducts/", $config_vars['shop']."/". $config_vars['search']."/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=shop&action=mydownloads&sub=showfile&Id=([0-9]*)&FileId=([0-9]*)&getId=([0-9]*)/", $config_vars['shop']."/". $config_vars['shop_download']."/\\2/\\3/\\4/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=shop&amp;action=showproducts&amp;page=([0-9]*)&amp;cid=([0-9]*)&amp;limit=([0-9]*)&amp;list=([-_A-Za-zÀ-ÖØ-öø-ÿ-]*)/", $config_vars['shop']."/".$config_vars['shop_products']."/\\2/\\3/".$config_vars['shop_new_products']."/\\4/\\5/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=shop&amp;action=showproducts&amp;page=([0-9]*)&amp;cid=([0-9]*)&amp;limit=([0-9]*)/", $config_vars['shop']."/".$config_vars['shop_products']."/\\2/\\3/".$config_vars['shop_new_products']."/\\4/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=shop&amp;action=showproducts&amp;page=([0-9]*)&amp;offers=1&amp;cid=([0-9]*)&amp;limit=([0-9]*)&amp;list=([-_A-Za-zÀ-ÖØ-öø-ÿ-]*)/", $config_vars['shop']."/".$config_vars['shop_products']."/\\2/\\3/".$config_vars['shop_offer_products']."/\\4/\\5/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=shop&amp;action=showproducts&amp;page=([0-9]*)&amp;offers=1&amp;cid=([0-9]*)&amp;limit=([0-9]*)/", $config_vars['shop']."/".$config_vars['shop_products']."/\\2/\\3/".$config_vars['shop_offer_products']."/\\4/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=shop&amp;action=showproducts&amp;page=([0-9]*)&amp;lowamount=1&amp;cid=([0-9]*)&amp;limit=([0-9]*)&amp;list=([-_A-Za-zÀ-ÖØ-öø-ÿ-]*)/", $config_vars['shop']."/".$config_vars['shop_products']."/\\2/\\3/".$config_vars['shop_lowamount_products']."/\\4/\\5/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=shop&amp;action=showproducts&amp;page=([0-9]*)&amp;lowamount=1&amp;cid=([0-9]*)&amp;limit=([0-9]*)/", $config_vars['shop']."/".$config_vars['shop_products']."/\\2/\\3/".$config_vars['shop_lowamount_products']."/\\4/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=shop&amp;action=showproducts&amp;page=([0-9]*)&amp;cid=([0-9]*)&amp;list=([-=_A-Za-zÀ-ÖØ-öø-ÿ- ]*)/", $config_vars['shop']."/".$config_vars['shop_products']."/\\2/\\3/".$config_vars['shop_new_products']."/\\4/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=shop&amp;action=showproducts&amp;page=([0-9]*)&amp;offers=1&amp;cid=([0-9]*)&amp;list=([-=_A-Za-zÀ-ÖØ-öø-ÿ- ]*)/", $config_vars['shop']."/".$config_vars['shop_products']."/\\2/\\3/".$config_vars['shop_offer_products']."/\\4/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=shop&amp;action=showproducts&amp;page=([0-9]*)&amp;lowamount=1&amp;cid=([0-9]*)&amp;list=([-=_A-Za-zÀ-ÖØ-öø-ÿ- ]*)/", $config_vars['shop']."/".$config_vars['shop_products']."/\\2/\\3/".$config_vars['shop_lowamount_products']."/\\4/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=shop&amp;action=showproducts&amp;page=([0-9]*)&amp;cid=([0-9]*)/", $config_vars['shop']."/".$config_vars['shop_products']."/\\2/\\3/".$config_vars['shop_new_products']."/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=shop&amp;action=showproducts&amp;page=([0-9]*)&amp;offers=1&amp;cid=([0-9]*)/", $config_vars['shop']."/".$config_vars['shop_products']."/\\2/\\3/".$config_vars['shop_offer_products']."/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=shop&amp;action=showproducts&amp;page=([0-9]*)&amp;lowamount=1&amp;cid=([0-9]*)/", $config_vars['shop']."/".$config_vars['shop_products']."/\\2/\\3/".$config_vars['shop_lowamount_products']."/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=shop&amp;action=showproducts&amp;page=([0-9]*)&amp;topseller=1&amp;cid=([0-9]*)&amp;limit=([0-9]*)&amp;list=([-_A-Za-zÀ-ÖØ-öø-ÿ-]*)/", $config_vars['shop']."/".$config_vars['shop_products']."/\\2/\\3/".$config_vars['shop_topseller_products']."/\\4/\\5/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=shop&amp;action=showproducts&amp;page=([0-9]*)&amp;topseller=1&amp;cid=([0-9]*)&amp;limit=([0-9]*)/", $config_vars['shop']."/".$config_vars['shop_products']."/\\2/\\3/".$config_vars['shop_topseller_products']."/\\4/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=shop&amp;action=showproducts&amp;page=([0-9]*)&amp;topseller=1&amp;cid=([0-9]*)&amp;list=([-=_A-Za-zÀ-ÖØ-öø-ÿ- ]*)/", $config_vars['shop']."/".$config_vars['shop_products']."/\\2/\\3/".$config_vars['shop_topseller_products']."/\\4/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=shop&amp;action=showproducts&amp;page=([0-9]*)&amp;topseller=1&amp;cid=([0-9]*)/", $config_vars['shop']."/".$config_vars['shop_products']."/\\2/\\3/".$config_vars['shop_topseller_products']."/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=shop&amp;action=showproducts&amp;page=([0-9]*)&amp;topseller=1&amp;limit=([0-9]*)/", $config_vars['shop']."/".$config_vars['shop_products']."/\\2/".$config_vars['shop_topseller_products']."/\\3/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=shop&amp;action=showproducts&amp;page=([0-9]*)&amp;topseller=1/", $config_vars['shop']."/".$config_vars['shop_products']."/\\2/".$config_vars['shop_topseller_products']."/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=shop&amp;action=showproducts&amp;page=([0-9]*)&amp;topseller=1&amp;list=([-=_A-Za-zÀ-ÖØ-öø-ÿ- ]*)/", $config_vars['shop']."/".$config_vars['shop_products']."/\\2/".$config_vars['shop_topseller_products']."/\\3/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=shop&amp;area=([0-9]*)&amp;action=showseenproducts/", $config_vars['shop']."/".$config_vars['showseenproducts']."/\\2/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=shop&amp;action=dataprotect/", $config_vars['shop']."/".$config_vars['shop_dataprotection']."/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=shop&amp;action=showproducts&amp;man=([0-9]*)/", $config_vars['shop_manufacturer_first'].'/'.$config_vars['shop_manufacturer']."/\\2/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=shop&amp;action=agb/", $config_vars['shop']."/".$config_vars['shop_agb']."/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=shop&amp;area=([0-9]*)/", $config_vars['shop']."/\\2/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=shop/", $config_vars['shop']."/", $Ausgabe);
	} else {
		$Ausgabe = preg_replace("/index.php([?])p=shop&amp;action=showproduct&amp;id=([0-9]*)&amp;cid=([0-9]*)&amp;pname=([-=_A-Za-zÀ-ÖØ-öø-ÿ0-9- ]*)/", $config_vars['shop']."/".$config_vars['shop_product']."/\\2/\\3/\\4/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=shop&amp;action=mydownloads/", $config_vars['shop']."/". $config_vars['mydownloads']."/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=shop&amp;action=myorders/", $config_vars['shop']."/". $config_vars['myorders']."/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=shop&amp;area=([0-9]*)/", $config_vars['shop']."/\\2/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=shop/", $config_vars['shop']."/", $Ausgabe);
	}
	
	// Galerie
	if($_REQUEST['p']=='gallery')
	{
		$Ausgabe = preg_replace("/index.php([?])ascdesc=([_A-Za-zÀ-ÖØ-öø-ÿ0-9-]*)&amp;p=gallery&amp;action=showimage&amp;id=([0-9]*)&amp;galid=([0-9]*)&amp;categ=([0-9]*)&amp;blanc=1&amp;first_id=([0-9]*)/", $config_vars['gallery'] . "/" . $config_vars['gallerydiashow']."/\\2/\\3/\\6/\\5/\\4/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=gallery&amp;action=showimage&amp;id=([0-9]*)&amp;galid=([0-9]*)&amp;blanc=1&amp;first_id=([0-9]*)&amp;ascdesc=([_A-Za-zÀ-ÖØ-öø-ÿ0-9-]*)&amp;categ=([0-9]*)/", $config_vars['gallery'] . "/" . $config_vars['gallerydiashow']."/\\2/\\3/\\4/\\5/\\6/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=gallery&amp;action=showgallery&amp;id=([0-9]*)&amp;categ=([0-9]*)&amp;name=([A-Za-zÀ-ÖØ-öø-ÿ0-9-]*)&amp;ascdesc=([A-Za-zÀ-ÖØ-öø-ÿ0-9-]*)&amp;pp=([0-9]*)&amp;page=([0-9]*)&amp;favorites=1&amp;area=([0-9]*)/", $config_vars['gallery']."/" . $config_vars['galleryimages'] . "/\\2/\\3/\\4/\\5/\\6/\\7/". $config_vars['galleryfavs'] . "/\\8/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=gallery&amp;action=showgallery&amp;id=([0-9]*)&amp;categ=([0-9]*)&amp;name=([A-Za-zÀ-ÖØ-öø-ÿ0-9-]*)&amp;ascdesc=([A-Za-zÀ-ÖØ-öø-ÿ0-9-]*)&amp;pp=([0-9]*)&amp;page=([0-9]*)&amp;area=([0-9]*)/", $config_vars['gallery']."/" . $config_vars['galleryimages'] . "/\\2/\\3/\\4/\\5/\\6/\\7/\\8/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=gallery&amp;action=showimage&amp;id=([0-9]*)&amp;galid=([0-9]*)&amp;ascdesc=([A-Za-zÀ-ÖØ-öø-ÿ0-9-]*)&amp;categ=([0-9]*)&amp;area=([0-9]*)&amp;page=([0-9]*)/", $config_vars['gallery']."/" . $config_vars['galleryimage'] . "/\\2/\\3/\\4/\\5/\\6/\\7/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=gallery&amp;action=showimage&amp;id=([0-9]*)&amp;galid=([0-9]*)&amp;ascdesc=([A-Za-zÀ-ÖØ-öø-ÿ0-9-]*)&amp;categ=([0-9]*)&amp;area=([0-9]*)/", $config_vars['gallery']."/" . $config_vars['galleryimage'] . "/\\2/\\3/\\4/\\5/\\6/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=gallery&amp;action=showgallery&amp;id=([0-9]*)&amp;categ=([0-9]*)&amp;name=([_A-Za-zÀ-ÖØ-öø-ÿ0-9-]*)&amp;area=([0-9]*)/", $config_vars['gallery']."/" . $config_vars['galleryimages'] . "/\\2/\\3/\\4/\\5/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=gallery&amp;q=([A-Za-zÀ-ÖØ-öø-ÿ0-9-]*)&amp;searchtype=([A-Za-zÀ-ÖØ-öø-ÿ0-9-]*)&amp;ascdesc=([A-Za-zÀ-ÖØ-öø-ÿ0-9-]*)&amp;page=([0-9]*)&amp;area=([0-9]*)/", $config_vars['gallery']."/\\2/\\3/\\4/\\5/\\6/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=gallery&amp;action=showgallery&amp;id=([0-9]*)&amp;categ=([0-9]*)&amp;name=([_A-Za-zÀ-ÖØ-öø-ÿ0-9-]*)&amp;favorites=1&amp;area=([0-9]*)/", $config_vars['gallery']."/" . $config_vars['galleryimages'] . "/\\2/\\3/\\4/" . $config_vars['galleryfavs'] . "/\\5/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=gallery&amp;action=showincluded&amp;categ=([0-9]*)&amp;name=([_A-Za-zÀ-ÖØ-öø-ÿ0-9-]*)&amp;q=([_A-Za-zÀ-ÖØ-öø-ÿ0-9-]*)&amp;searchtype=([_A-Za-zÀ-ÖØ-öø-ÿ0-9-]*)&amp;page=([0-9]*)&amp;sort=([_A-Za-zÀ-ÖØ-öø-ÿ0-9-]*)&amp;area=([0-9]*)/", $config_vars['gallery']."/\\2/\\3/\\4/\\5/\\6/\\7/\\8/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=gallery&amp;action=showincluded&amp;categ=([0-9]*)&amp;name=([_A-Za-zÀ-ÖØ-öø-ÿ0-9-]*)&amp;area=([0-9]*)/", $config_vars['gallery']."/\\2/\\3/\\4/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=gallery&amp;action=showgallery&amp;area=([0-9]*)/", $config_vars['gallery']."/\\2/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=gallery&amp;area=([0-9]*)/", $config_vars['gallery']."/\\2/", $Ausgabe);
	} else {
		$Ausgabe = preg_replace("/index.php([?])p=gallery&amp;action=showgallery&amp;id=([0-9]*)&amp;categ=([0-9]*)&amp;name=([_A-Za-zÀ-ÖØ-öø-ÿ0-9-]*)&amp;area=([0-9]*)/", $config_vars['gallery']."/" . $config_vars['galleryimages'] . "/\\2/\\3/\\4/\\5/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=gallery&amp;area=([0-9]*)/", $config_vars['gallery']."/\\2/", $Ausgabe);
	}
	
	// Umfrage
	$Ausgabe = preg_replace("/index.php([?])p=poll&amp;id=([0-9]*)&amp;name=([_A-Za-zÀ-ÖØ-öø-ÿ0-9-]*)&amp;page=([0-9]*)&amp;area=([0-9]*)/", $config_vars['poll']."/\\2/\\3/\\4/\\5/", $Ausgabe);
	$Ausgabe = preg_replace("/index.php([?])p=poll&amp;id=([0-9]*)&amp;name=([_A-Za-zÀ-ÖØ-öø-ÿ0-9-]*)&amp;area=([0-9]*)/", $config_vars['poll']."/\\2/\\3/\\4/", $Ausgabe);
	$Ausgabe = preg_replace("/index.php([?])p=poll&amp;action=archive&amp;page=([0-9]*)&amp;area=([0-9]*)/", $config_vars['pollarchive']."/\\2/\\3/", $Ausgabe);
	$Ausgabe = preg_replace("/index.php([?])p=poll&amp;action=archive&amp;area=([0-9]*)/", $config_vars['pollarchive']."/\\2/", $Ausgabe);
	$Ausgabe = preg_replace("/index.php([?])p=poll&amp;area=([0-9]*)/", $config_vars['poll']."/\\2/", $Ausgabe);

	// News
	$Ausgabe = preg_replace("/index.php([?])p=news&amp;area=([0-9]*)&amp;newsid=([0-9]*)&amp;name=([_A-Za-zÀ-ÖØ-öø-ÿ0-9-]*)&amp;artpage=([0-9]*)/", $config_vars['news']."/\\2/\\3/\\4/\\5/", $Ausgabe);
	$Ausgabe = preg_replace("/index.php([?])p=news&amp;newsid=([0-9]*)&amp;name=([_A-Za-zÀ-ÖØ-öø-ÿ0-9-]*)&amp;page=([0-9]*)&amp;area=([0-9]*)/", $config_vars['news']."/\\2/\\3/\\4/\\5/", $Ausgabe);
	$Ausgabe = preg_replace("/index.php([?])p=news&amp;area=([0-9]*)&amp;newsid=([0-9]*)&amp;name=([_A-Za-zÀ-ÖØ-öø-ÿ0-9-]*)/", $config_vars['news']."/\\2/\\3/\\4/", $Ausgabe);
	$Ausgabe = preg_replace("/index.php([?])p=newsarchive&amp;area=([0-9]*)&amp;catid=([0-9]*)&amp;name=([_A-Za-zÀ-ÖØ-öø-ÿ0-9-]*)/", $config_vars['newsarchive']."/\\2/\\3/\\4/", $Ausgabe);
	$Ausgabe = preg_replace("/index.php([?])p=newsarchive&amp;area=([0-9]*)&amp;catid=([0-9]*)/", $config_vars['newsarchive']."/\\2/\\3/", $Ausgabe);
	$Ausgabe = preg_replace("/index.php([?])area=([0-9]*)&amp;p=newsarchive&amp;catid=([0-9]*)&amp;t=1&amp;mode=rss/", $config_vars['newsrss']."/\\2/\\3/", $Ausgabe);
	$Ausgabe = preg_replace("/index.php([?])p=newsarchive&amp;area=([0-9]*)&amp;mode=rss/", $config_vars['newsrss']."/\\2/", $Ausgabe);
	$Ausgabe = preg_replace("/index.php([?])p=newsarchive&amp;area=([0-9]*)/", $config_vars['newsarchive']."/\\2/", $Ausgabe);
	$Ausgabe = preg_replace("/index.php([?])p=content&amp;id=([0-9]*)&amp;name=([_A-Za-zÀ-ÖØ-öø-ÿ0-9-]*)&amp;page=([0-9]*)&amp;area=([0-9]*)#comments/", $config_vars['content']."/\\2/\\3/\\5/" . $config_vars['page'] . "/\\4/#comments", $Ausgabe);
	$Ausgabe = preg_replace("/index.php([?])p=content&amp;id=([0-9]*)&amp;name=([_A-Za-zÀ-ÖØ-öø-ÿ0-9-]*)&amp;area=([0-9]*)&amp;artpage=([0-9]*)/", $config_vars['content']."/\\2/\\3/\\4/\\5/", $Ausgabe);
	$Ausgabe = preg_replace("/index.php([?])p=content&amp;id=([0-9]*)&amp;name=([_A-Za-zÀ-ÖØ-öø-ÿ0-9-]*)&amp;area=([0-9]*)/", $config_vars['content']."/\\2/\\3/\\4/", $Ausgabe);
	
	$Ausgabe = preg_replace("/index.php([?])p=articles&amp;area=([0-9]*)&amp;catid=([0-9]*)&amp;page=([0-9]*)&amp;q_news=([_A-Za-zÀ-ÖØ-öø-ÿ0-9-+]*)&amp;limit=([0-9]*)/", $config_vars['articles_archive']."/\\2/\\3/\\4/\\5/\\6/", $Ausgabe);
	$Ausgabe = preg_replace("/index.php([?])p=articles&amp;area=([0-9]*)&amp;catid=([0-9]*)&amp;page=([0-9]*)&amp;limit=([0-9]*)/", $config_vars['articles_archive']."/\\2/\\3/\\4/\\5/", $Ausgabe);
	
	$Ausgabe = preg_replace("/index.php([?])p=articles&amp;area=([0-9]*)&amp;catid=([0-9]*)&amp;name=([_A-Za-zÀ-ÖØ-öø-ÿ0-9-+]*)/", $config_vars['articles_archive']."/\\2/\\3/\\4/", $Ausgabe);
	
	$Ausgabe = preg_replace("/index.php([?])p=articles&amp;area=([0-9]*)&amp;action=displayarticle&amp;id=([0-9]*)&amp;name=([_A-Za-zÀ-ÖØ-öø-ÿ0-9-]*)&amp;artpage=([0-9]*)/", $config_vars['articles']."/\\2/\\3/\\4/\\5/", $Ausgabe);
	$Ausgabe = preg_replace("/index.php([?])p=articles&amp;area=([0-9]*)&amp;action=displayarticle&amp;id=([0-9]*)&amp;name=([_A-Za-zÀ-ÖØ-öø-ÿ0-9-]*)/", $config_vars['articles']."/\\2/\\3/\\4/", $Ausgabe);
	
	$Ausgabe = preg_replace("/index.php([?])p=articles&amp;area=([0-9]*)&amp;type=reviews/", $config_vars['articles']."/". $config_vars['articles_reviews']."/\\2/", $Ausgabe);
	$Ausgabe = preg_replace("/index.php([?])p=articles&amp;area=([0-9]*)&amp;type=previews/", $config_vars['articles']."/". $config_vars['articles_previews']."/\\2/", $Ausgabe);
	$Ausgabe = preg_replace("/index.php([?])p=articles&amp;area=([0-9]*)&amp;type=specials/", $config_vars['articles']."/". $config_vars['articles_specials']."/\\2/", $Ausgabe);
	$Ausgabe = preg_replace("/index.php([?])p=articles&amp;area=([0-9]*)&amp;mode=rss/", $config_vars['articles_rss']."/\\2/", $Ausgabe);
	$Ausgabe = preg_replace("/index.php([?])p=articles&amp;area=([0-9]*)/", $config_vars['articles']."/\\2/", $Ausgabe);
	
	// Links
	if($_REQUEST['p']=='links')
	{
		$Ausgabe = preg_replace("/index.php([?])p=links&amp;action=showdetails&amp;categ=([0-9]*)&amp;id=([0-9]*)&amp;name=([_A-Za-zÀ-ÖØ-öø-ÿ0-9-]*)&amp;page=([0-9]*)&amp;area=([0-9]*)/", $config_vars['links']."/\\2/\\3/\\4/\\5/\\6/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=links&amp;action=showdetails&amp;area=([0-9]*)&amp;categ=([0-9]*)&amp;id=([0-9]*)&amp;name=([_A-Za-zÀ-ÖØ-öø-ÿ0-9-]*)/", $config_vars['links']."/\\2/\\3/\\4/\\5/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=links&amp;area=([0-9]*)&amp;categ=([0-9]*)&amp;name=([_A-Za-zÀ-ÖØ-öø-ÿ0-9-]*)&amp;page=([0-9]*)&amp;sort=([_A-Za-zÀ-ÖØ-öø-ÿ0-9-]*)/", $config_vars['links']."/\\2/\\3/\\4/\\5/\\6/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=links&amp;area=([0-9]*)&amp;categ=([0-9]*)&amp;name=([_A-Za-zÀ-ÖØ-öø-ÿ0-9-]*)&amp;page=([0-9]*)/", $config_vars['links']."/\\2/\\3/\\4/\\5/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=links&amp;area=([0-9]*)&amp;categ=([0-9]*)&amp;name=([_A-Za-zÀ-ÖØ-öø-ÿ0-9-]*)/", $config_vars['links']."/\\2/\\3/\\4/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=links&amp;area=([0-9]*)&amp;action=search/", $config_vars['links']."/" . $config_vars['links_search'] . "/\\2/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])?ql=([_A-Za-zÀ-ÖØ-öø-ÿ0-9-+]*)&amp;action=search&amp;p=links&amp;area=([0-9]*)&amp;page=([0-9]*)/", $config_vars['links']."/" . $config_vars['links_search'] . "/\\2/\\3/\\4/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=links&amp;area=([0-9]*)/", $config_vars['links']."/\\2/", $Ausgabe);
	} else {
		$Ausgabe = preg_replace("/index.php([?])p=links&amp;action=showdetails&amp;area=([0-9]*)&amp;categ=([0-9]*)&amp;id=([0-9]*)&amp;name=([_A-Za-zÀ-ÖØ-öø-ÿ0-9-]*)/", $config_vars['links']."/\\2/\\3/\\4/\\5/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=links&amp;area=([0-9]*)/", $config_vars['links']."/\\2/", $Ausgabe);
	}
	
	if($_REQUEST['p']=='downloads')
	{
		$Ausgabe = preg_replace("/index.php([?])p=downloads&amp;action=showdetails&amp;categ=([0-9]*)&amp;id=([0-9]*)&amp;name=([_A-Za-zÀ-ÖØ-öø-ÿ0-9-]*)&amp;page=([0-9]*)&amp;area=([0-9]*)/", $config_vars['downloads']."/\\2/\\3/\\4/\\5/\\6/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=downloads&amp;action=showdetails&amp;area=([0-9]*)&amp;categ=([0-9]*)&amp;id=([0-9]*)&amp;name=([_A-Za-zÀ-ÖØ-öø-ÿ0-9-]*)/", $config_vars['downloads']."/\\2/\\3/\\4/\\5/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=downloads&amp;area=([0-9]*)&amp;categ=([0-9]*)&amp;name=([_A-Za-zÀ-ÖØ-öø-ÿ0-9-]*)&amp;page=([0-9]*)&amp;sort=([_A-Za-zÀ-ÖØ-öø-ÿ0-9-]*)/", $config_vars['downloads']."/\\2/\\3/\\4/\\5/\\6/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=downloads&amp;area=([0-9]*)&amp;categ=([0-9]*)&amp;name=([_A-Za-zÀ-ÖØ-öø-ÿ0-9-]*)&amp;page=([0-9]*)/", $config_vars['downloads']."/\\2/\\3/\\4/\\5/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=downloads&amp;area=([0-9]*)&amp;categ=([0-9]*)&amp;name=([_A-Za-zÀ-ÖØ-öø-ÿ0-9-]*)/", $config_vars['downloads']."/\\2/\\3/\\4/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=downloads&amp;area=([0-9]*)&amp;action=search/", $config_vars['downloads']."/" . $config_vars['downloads_search'] . "/\\2/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])?ql=([_A-Za-zÀ-ÖØ-öø-ÿ0-9-+]*)&amp;action=search&amp;p=downloads&amp;area=([0-9]*)&amp;page=([0-9]*)/", $config_vars['downloads']."/" . $config_vars['downloads_search'] . "/\\2/\\3/\\4/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=downloads&amp;area=([0-9]*)/", $config_vars['downloads']."/\\2/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=downloads&amp;action=getfile&amp;id=([0-9]*)/", $config_vars['downloads_getfile']."/\\2/", $Ausgabe);
	} else {
		$Ausgabe = preg_replace("/index.php([?])p=downloads&amp;action=showdetails&amp;area=([0-9]*)&amp;categ=([0-9]*)&amp;id=([0-9]*)&amp;name=([_A-Za-zÀ-ÖØ-öø-ÿ0-9-]*)/", $config_vars['downloads']."/\\2/\\3/\\4/\\5/", $Ausgabe);
		$Ausgabe = preg_replace("/index.php([?])p=downloads&amp;area=([0-9]*)/", $config_vars['downloads']."/\\2/", $Ausgabe);
	}
	
	// Cheats
	$Ausgabe = preg_replace("/index.php([?])p=cheats&amp;action=showcheat&amp;area=([0-9]*)&amp;plattform=([0-9]*)&amp;id=([0-9]*)&amp;name=([_A-Za-zÀ-ÖØ-öø-ÿ0-9-]*)/", $config_vars['cheats']."/\\2/\\3/\\4/\\5/", $Ausgabe);
	$Ausgabe = preg_replace("/index.php([?])p=cheats&amp;area=([0-9]*)&amp;plattform=([0-9]*)&amp;name=([_A-Za-zÀ-ÖØ-öø-ÿ0-9-]*)&amp;page=([0-9]*)&amp;sort=([_A-Za-zÀ-ÖØ-öø-ÿ0-9-]*)/", $config_vars['cheats']."/\\2/\\3/\\4/".$config_vars['page']."/\\5/\\6/", $Ausgabe);
	$Ausgabe = preg_replace("/index.php([?])?ql=([_A-Za-zÀ-ÖØ-öø-ÿ0-9-+]*)&amp;action=search&amp;p=cheats&amp;area=([0-9]*)&amp;page=([0-9]*)/", $config_vars['cheats']."/" . $config_vars['cheats_search'] . "/\\2/\\3/\\4/", $Ausgabe);
	$Ausgabe = preg_replace("/index.php([?])p=cheats&amp;area=([0-9]*)&amp;plattform=([0-9]*)&amp;name=([_A-Za-zÀ-ÖØ-öø-ÿ0-9-]*)/", $config_vars['cheats']."/\\2/\\3/\\4/", $Ausgabe);
	$Ausgabe = preg_replace("/index.php([?])p=cheats&amp;area=([0-9]*)&amp;action=search/", $config_vars['cheats']."/" . $config_vars['cheats_search'] . "/\\2/", $Ausgabe);
	$Ausgabe = preg_replace("/index.php([?])p=cheats&amp;area=([0-9]*)/", $config_vars['cheats']."/\\2/", $Ausgabe);
	$Ausgabe = preg_replace("/index.php([?])p=cheats&amp;action=getfile&amp;id=([0-9]*)/", $config_vars['cheats_getfile']."/\\2/", $Ausgabe);
	
	
	$Ausgabe = preg_replace("/index.php([?])p=calendar&amp;action=events&amp;show=([_A-Za-zÀ-ÖØ-öø-ÿ0-9-]*)&amp;koobi_monat=([0-9]*)&amp;koobi_jahr=([0-9]*)&amp;koobi_tag=([0-9]*)&amp;area=([0-9]*)/", $config_vars['calendar']."/".$config_vars['calendar_events']."/\\2/\\3/\\4/\\5/\\6/", $Ausgabe);
	$Ausgabe = preg_replace("/index.php([?])p=calendar&amp;show=([_A-Za-zÀ-ÖØ-öø-ÿ0-9-]*)&amp;action=week&amp;weekstart=([0-9]*)&amp;weekend=([0-9]*)&amp;area=([0-9]*)/", $config_vars['calendar']."/".$config_vars['calendar_week']."/\\2/\\3/\\4/\\5/", $Ausgabe);
	$Ausgabe = preg_replace("/index.php([?])p=calendar&amp;area=([0-9]*)&amp;action=displayyear&amp;show=([_A-Za-zÀ-ÖØ-öø-ÿ0-9-]*)&amp;koobi_jahr=([0-9]*)/", $config_vars['calendar']."/".$config_vars['calendar_year']."/\\2/\\3/\\4/", $Ausgabe);
	$Ausgabe = preg_replace("/index.php([?])p=calendar&amp;koobi_monat=([0-9]*)&amp;koobi_jahr=([0-9]*)&amp;area=([0-9]*)&amp;show=([_A-Za-zÀ-ÖØ-öø-ÿ0-9-]*)/", $config_vars['calendar']."/\\2/\\3/\\4/\\5/", $Ausgabe);
	$Ausgabe = preg_replace("/index.php([?])p=calendar&amp;koobi_monat=([0-9]*)&amp;koobi_jahr=([0-9]*)&amp;area=([0-9]*)/", $config_vars['calendar']."/\\2/\\3/\\4/", $Ausgabe);
	$Ausgabe = preg_replace("/index.php([?])p=calendar&amp;area=([0-9]*)&amp;action=myevents/", $config_vars['calendar']."/".$config_vars['calendar_myevents']."/\\2/", $Ausgabe);
	$Ausgabe = preg_replace("/index.php([?])p=calendar&amp;area=([0-9]*)&amp;action=newevent&amp;koobi_monat=([0-9]*)&amp;koobi_jahr=([0-9]*)&amp;area=([0-9]*)&amp;show=([_A-Za-zÀ-ÖØ-öø-ÿ0-9-]*)/", $config_vars['calendar']."/".$config_vars['calendar_newevent']."/\\2/\\3/\\4/\\5/", $Ausgabe);
	$Ausgabe = preg_replace("/index.php([?])p=calendar&amp;area=([0-9]*)/", $config_vars['calendar']."/\\2/", $Ausgabe);
	
	$Ausgabe = preg_replace("/index.php([?])p=products&amp;area=([0-9]*)&amp;page=([0-9]*)&amp;sort=([_A-Za-zÀ-ÖØ-öø-ÿ0-9-]*)&amp;q=([_A-Za-zÀ-ÖØ-öø-ÿ0-9-+]*)/", $config_vars['products']."/\\2/\\3/\\4/\\5/", $Ausgabe);
	$Ausgabe = preg_replace("/index.php([?])p=products&amp;area=([0-9]*)&amp;page=([0-9]*)&amp;sort=([_A-Za-zÀ-ÖØ-öø-ÿ0-9-]*)/", $config_vars['products']."/".$config_vars['page'] . "/\\2/\\3/\\4/", $Ausgabe);
	$Ausgabe = preg_replace("/index.php([?])p=products&amp;area=([0-9]*)&amp;action=showproduct&amp;id=([0-9]*)&amp;name=([_A-Za-zÀ-ÖØ-öø-ÿ0-9-]*)&amp;artpage=([0-9+}{]*)/", $config_vars['products']."/\\2/\\3/\\4/".$config_vars['page']."/\\5/", $Ausgabe);
   	$Ausgabe = preg_replace("/index.php([?])p=products&amp;area=([0-9]*)&amp;action=showproduct&amp;id=([0-9]*)&amp;name=([_A-Za-zÀ-ÖØ-öø-ÿ0-9-]*)/", $config_vars['products']."/\\2/\\3/\\4/", $Ausgabe);
	$Ausgabe = preg_replace("/index.php([?])p=products&amp;area=([0-9]*)/", $config_vars['products']."/\\2/", $Ausgabe);
	
	
	$Ausgabe = preg_replace("/index.php([?])p=manufacturer&amp;area=([0-9]*)&amp;page=([0-9]*)&amp;sort=([_A-Za-zÀ-ÖØ-öø-ÿ0-9-]*)&amp;q=([_A-Za-zÀ-ÖØ-öø-ÿ0-9-+]*)/", $config_vars['manufacturer']."/\\2/\\3/\\4/\\5/", $Ausgabe);
	$Ausgabe = preg_replace("/index.php([?])p=manufacturer&amp;area=([0-9]*)&amp;page=([0-9]*)&amp;sort=([_A-Za-zÀ-ÖØ-öø-ÿ0-9-]*)/", $config_vars['manufacturer']."/".$config_vars['page'] . "/\\2/\\3/\\4/", $Ausgabe);
	$Ausgabe = preg_replace("/index.php([?])p=manufacturer&amp;area=([0-9]*)&amp;action=showdetails&amp;id=([0-9]*)&amp;name=([_A-Za-zÀ-ÖØ-öø-ÿ0-9-]*)/", $config_vars['manufacturer']."/\\2/\\3/\\4/", $Ausgabe);
	$Ausgabe = preg_replace("/index.php([?])p=manufacturer&amp;area=([0-9]*)/", $config_vars['manufacturer']."/\\2/", $Ausgabe);
	
	
	$Ausgabe = preg_replace("/index.php([?])p=faq&amp;faq_id=([0-9]*)&amp;area=([0-9]*)&amp;name=([_A-Za-zÀ-ÖØ-öø-ÿ0-9-]*)/", $config_vars['faq']."/\\2/\\3/\\4/", $Ausgabe);
	$Ausgabe = preg_replace("/index.php([?])p=faq&amp;area=([0-9]*)/", $config_vars['faq']."/\\2/", $Ausgabe);
	
	$Ausgabe = preg_replace("/index.php([?])p=sitemap&amp;area=([0-9]*)/", $config_vars['sitemap']."/\\2/", $Ausgabe);
	
	$Ausgabe = preg_replace("/index.php([?])p=guestbook&amp;area=([0-9]*)/", $config_vars['guestbook']."/\\2/", $Ausgabe);
	$Ausgabe = preg_replace("/index.php([?])p=guestbook&amp;page=([0-9]*)&amp;area=([0-9]*)/", $config_vars['guestbook']."/\\3/\\2/", $Ausgabe);

	$Ausgabe = preg_replace("/index.php([?])p=imprint/", $config_vars['imprint']."/", $Ausgabe);
	
	
	$Ausgabe = preg_replace("/index.php([?])p=newsletter&amp;area=([0-9]*)/", $config_vars['newsletter']."/\\2/", $Ausgabe);
	$Ausgabe = preg_replace("/index.php([?])area=([0-9]*)&amp;mode=rss/", $config_vars['startindex']."/\\2/rss.xml", $Ausgabe);
	$Ausgabe = preg_replace("/index.php([?])area=([0-9]*)/", $config_vars['startindex']."/\\2/", $Ausgabe);

	// ========================================================================
	// ENDE DER MODREWRITE-REGELN
	// ========================================================================

	// MODREWRITE VERHINDERN - SCHRITT 2
	$Ausgabe = preg_replace("/___REWRITE_TEXT_([0-9]*)___/e", '$treffer_textarea[0][\\1]', $Ausgabe);
	$Ausgabe = preg_replace("/___REWRITE_([0-9]*)___/e",' $treffer_rewrite[0][\\1]', $Ausgabe);

	return $Ausgabe;

}
?>